# wxHtmlHelpController Class Reference
[Help, HTML]

`#include <wx/html/helpctrl.h>`

## Detailed Description

This help controller provides an easy way of displaying HTML help in your application (see HTML Sample, test example).

The help system is based on books (see wxHtmlHelpController::AddBook). A book is a logical section of documentation (for example "User's Guide" or "Programmer's Guide" or "C++ Reference" or "wxWidgets Reference"). The help controller can handle as many books as you want.

Although this class has an API compatible with other wxWidgets help controllers as documented by wxHelpController, it is recommended that you use the enhanced capabilities of wxHtmlHelpController's API.

wxHTML uses Microsoft's HTML Help Workshop project files (.hhp, .hhk, .hhc) as its native format. The file format is described in Help Files Format. The directory `helpfiles` in the HTML Sample contains sample project files.

Note that the Microsoft's HTML Help Workshop (http://www.microsoft.com/downloads/details.aspx?FamilyID=00535334-c8a6-452f-9aa0-d597d16580cc) also runs on other platforms using WINE (http://www.winehq.org/) and it can be used to create the .hpp, .hhk and .hhc files through a friendly GUI. The commercial tool HelpBlocks (http://www.helpblocks.com) can also create these files.

##

Library: wxHTML

Category: Help, HTML

See also:
  wxBestHelpController, wxHtmlHelpFrame, wxHtmlHelpDialog, wxHtmlHelpWindow, wxHtmlModalHelp

## Public Member Functions
| wxHtmlHelpController (int style=wxHF_DEFAULT_STYLE, wxWindow *parentWindow=NULL)
| Constructor.
bool | AddBook (const wxFileName &bookFile, bool showWaitMsg=false)
| Adds a book (i.e.
bool | AddBook (const wxString &bookUrl, bool showWaitMsg=false)
| Adds a book (i.e.
bool | Display (const wxString &x)
| Displays page x.
bool | Display (int id)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. This alternative form is used to search help contents by numeric IDs.
virtual bool | DisplayContents ()
| Displays help window and focuses contents panel.
bool | DisplayIndex ()
| Displays help window and focuses index panel.
virtual bool | KeywordSearch (const wxString &keyword, wxHelpSearchMode mode=wxHELP_SEARCH_ALL)
| Displays the help window, focuses search panel and starts searching.
virtual void | ReadCustomization (wxConfigBase *cfg, const wxString &path=wxEmptyString)
| Reads the controller's setting (position of window, etc.
void | SetShouldPreventAppExit (bool enable)
| Sets whether the help frame should prevent application from exiting if it's the only remaining top level window.
void | SetTempDir (const wxString &path)
| Sets the path for storing temporary files - cached binary versions of index and contents files.
void | SetTitleFormat (const wxString &format)
| Sets format of title of the frame.
void | UseConfig (wxConfigBase *config, const wxString &rootpath=wxEmptyString)
| Associates the config object with the controller.
virtual void | WriteCustomization (wxConfigBase *cfg, const wxString &path=wxEmptyString)
| Stores controllers setting (position of window etc.
## Protected Member Functions
virtual wxHtmlHelpDialog * | CreateHelpDialog (wxHtmlHelpData *data)
| This protected virtual method may be overridden so that when specifying the `wxHF_DIALOG` style, the controller uses a different dialog.
virtual wxHtmlHelpFrame * | CreateHelpFrame (wxHtmlHelpData *data)
| This protected virtual method may be overridden so that the controller uses a different frame.

List of all members.

## Constructor & Destructor Documentation

wxHtmlHelpController::wxHtmlHelpController | ( | int | style = `wxHF_DEFAULT_STYLE`,
|  | wxWindow * | parentWindow = `NULL` |
| ) |  |  |

Constructor.

Parameters:

  | style | This is a combination of these flags: wxHF_TOOLBAR: The help window has a toolbar. wxHF_FLAT_TOOLBAR: The help window has a toolbar with flat buttons (aka coolbar). wxHF_CONTENTS: The help window has a contents panel. wxHF_INDEX: The help window has an index panel. wxHF_SEARCH: The help window has a search panel. wxHF_BOOKMARKS: The help window has bookmarks controls. wxHF_OPEN_FILES: Allows user to open arbitrary HTML document. wxHF_PRINT: The toolbar contains "print" button. wxHF_MERGE_BOOKS: The contents pane does not show book nodes. All books are merged together and appear as single book to the user. wxHF_ICONS_BOOK: All nodes in contents pane have a book icon. This is how Microsoft's HTML help viewer behaves. wxHF_ICONS_FOLDER: Book nodes in contents pane have a book icon, book's sections have a folder icon. This is the default. wxHF_ICONS_BOOK_CHAPTER: Both book nodes and nodes of top-level sections of a book (i.e. chapters) have a book icon, all other sections (sections, subsections, ...) have a folder icon. wxHF_EMBEDDED: Specifies that the help controller controls an embedded window of class wxHtmlHelpWindow that should not be destroyed when the controller is destroyed. wxHF_DIALOG: Specifies that the help controller should create a dialog containing the help window. wxHF_FRAME: Specifies that the help controller should create a frame containing the help window. This is the default if neither wxHF_DIALOG nor wxHF_EMBEDDED is specified. wxHF_MODAL: Specifies that the help controller should create a modal dialog containing the help window (used with the wxHF_DIALOG style). wxHF_DEFAULT_STYLE: wxHF_TOOLBAR | wxHF_CONTENTS | wxHF_INDEX | wxHF_SEARCH | wxHF_BOOKMARKS | wxHF_PRINT
  | parentWindow | This is an optional window to be used as the parent for the help window.

## Member Function Documentation

bool wxHtmlHelpController::AddBook | ( | const wxString & | bookUrl,
|  | bool | showWaitMsg = `false` |
| ) |  |  |

Adds a book (i.e.

a .hhp file; an HTML Help Workshop project file) into the list of loaded books.

See the other overload for additional info.

Parameters:

  | bookUrl | Help book URL (note that syntax of filename and URL is different on most platforms).
  | showWaitMsg | If true then a decoration-less window with progress message is displayed.

bool wxHtmlHelpController::AddBook | ( | const wxFileName & | bookFile,
|  | bool | showWaitMsg = `false` |
| ) |  |  |

Adds a book (i.e.

a .hhp file; an HTML Help Workshop project file) into the list of loaded books.

This must be called at least once before displaying any help. bookFile or bookUrl may be either `".hhp"` file or a ZIP archive that contains an arbitrary number of `".hhp"` files in its top-level directory. This ZIP archive must have `".zip"` or `".htb"` extension (the latter stands for "HTML book"). In other words,

            AddBook(wxFileName("help.zip"))

is possible and is the recommended way.

Parameters:

  | bookFile | Help book filename. It is recommended to use this prototype instead of the one taking URL, because it is less error-prone.
  | showWaitMsg | If true then a decoration-less window with progress message is displayed.

virtual wxHtmlHelpDialog* wxHtmlHelpController::CreateHelpDialog | ( | wxHtmlHelpData * | data | ) | `[protected, virtual]`

This protected virtual method may be overridden so that when specifying the `wxHF_DIALOG` style, the controller uses a different dialog.

virtual wxHtmlHelpFrame* wxHtmlHelpController::CreateHelpFrame | ( | wxHtmlHelpData * | data | ) | `[protected, virtual]`

This protected virtual method may be overridden so that the controller uses a different frame.

bool wxHtmlHelpController::Display | ( | int | id | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. This alternative form is used to search help contents by numeric IDs.

bool wxHtmlHelpController::Display | ( | const wxString & | x | ) |

Displays page x.

This is THE important function - it is used to display the help in application. You can specify the page in many ways:

- as direct filename of HTML document
- as chapter name (from contents) or as a book name
- as some word from index
- even as any word (will be searched)

Looking for the page runs in these steps:

1. try to locate file named x (if x is for example "doc/howto.htm")
2. try to open starting page of book named x
3. try to find x in contents (if x is for example "How To ...")
4. try to find x in index (if x is for example "How To ...")
5. switch to Search panel and start searching

virtual bool wxHtmlHelpController::DisplayContents | ( |  | ) | `[virtual]`

Displays help window and focuses contents panel.

bool wxHtmlHelpController::DisplayIndex | ( |  | ) |

Displays help window and focuses index panel.

virtual bool wxHtmlHelpController::KeywordSearch | ( | const wxString & | keyword,
|  | wxHelpSearchMode | mode = `wxHELP_SEARCH_ALL` |
| ) |  |  | `[virtual]`

Displays the help window, focuses search panel and starts searching.

Returns true if the keyword was found. Optionally it searches through the index (mode = `wxHELP_SEARCH_INDEX`), default the content (mode = `wxHELP_SEARCH_ALL`).

Note:
  KeywordSearch() searches only pages listed in `".hhc"` file(s). You should list all pages in the contents file.

virtual void wxHtmlHelpController::ReadCustomization | ( | wxConfigBase * | cfg,
|  | const wxString & | path = `wxEmptyString` |
| ) |  |  | `[virtual]`

Reads the controller's setting (position of window, etc.

)

void wxHtmlHelpController::SetShouldPreventAppExit | ( | bool | enable | ) |

Sets whether the help frame should prevent application from exiting if it's the only remaining top level window.

If true, the application will not quit unless the help frame is closed. Default is false, i.e. the application does exit if only the help window remains opened.

See also:
  wxApp::SetExitOnFrameDelete()

Since:
  2.9.2

void wxHtmlHelpController::SetTempDir | ( | const wxString & | path | ) |

Sets the path for storing temporary files - cached binary versions of index and contents files.

These binary forms are much faster to read. Default value is empty string (empty string means that no cached data are stored). Note that these files are not deleted when program exits.

Once created these cached files will be used in all subsequent executions of your application. If cached files become older than corresponding `".hhp"` file (e.g. if you regenerate documentation) it will be refreshed.

void wxHtmlHelpController::SetTitleFormat | ( | const wxString & | format | ) |

Sets format of title of the frame.

Must contain exactly one "%s" (for title of displayed HTML page).

void wxHtmlHelpController::UseConfig | ( | wxConfigBase * | config,
|  | const wxString & | rootpath = `wxEmptyString` |
| ) |  |  |

Associates the config object with the controller.

If there is associated config object, wxHtmlHelpController automatically reads and writes settings (including wxHtmlWindow's settings) when needed. The only thing you must do is create wxConfig object and call UseConfig().

If you do not use UseConfig(), wxHtmlHelpController will use the default wxConfig object if available (for details see wxConfigBase::Get and wxConfigBase::Set).

virtual void wxHtmlHelpController::WriteCustomization | ( | wxConfigBase * | cfg,
|  | const wxString & | path = `wxEmptyString` |
| ) |  |  | `[virtual]`

Stores controllers setting (position of window etc.

)

|  | [ top ]